<template>
  <div class="searchbar">
    <input 
      type="text" 
      placeholder="جست و جو" 
      id="search" 
      v-model="searchValue"
      autocomplete="off" 
      autocorrect="off" 
      spellcheck="false" 
      maxlength="524288"
      />
    <Button type="text" size="sm" round color="white" @click.native="search">
      <template #icon>
        <SearchIcon />
      </template>
    </Button>
    <Button type="text" size="sm" round class="close" color="white" @click.native="close">
      <template #icon>
        <CloseIcon />
      </template>
    </Button>
  </div>
</template>

<script>
import Button from "@/components/base/Button";
import CloseIcon from "@/assets/svgs/close.svg";
import SearchIcon from "@/assets/svgs/search.svg";

export default {
  name: "SearchBar",
  components: {
    Button,
    CloseIcon,
    SearchIcon
  },
  data() {
    return {
      searchValue: ""
    }
  },
  methods: {
    close() {
      this.$emit('close');
    },
    search(e) {
      if (((e.type === "keyup" && e.key === "Enter") || e.type === "click") && this.searchValue) {
        this.$router.push({path: "/shop/search", query: {
          query: this.searchValue
        }});
      }
    }
  },
  mounted() {
    document.getElementById('search').addEventListener("keyup", this.search);
    document.getElementById('search').focus();
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"
.searchbar
  width 100%
  background-color $black-lighter
  height $shop-toolbar-height
  display flex
  align-items center
  direction rtl

input 
  border none 
  align-self stretch
  font-family inherit 
  font-size $font-size
  background-color transparent
  padding $sm $lg
  min-width 4rem
  flex-grow 1
  color $white
  outline none
  @media only screen and (max-width: 600px)
    padding $sm $md
  @media only screen and (max-width: 440px)
    padding $sm

.close
  margin-left $md
  @media only screen and (max-width: 600px)
    margin-left $sm
  @media only screen and (max-width: 440px)
    margin-left $xsm
</style>